using NAnt.Core;

namespace Nant.VMWare.Tasks
{
    public abstract class VirtualMachineTask : Task
    {
        protected static VmWareConfiguration Configuration;
        private static TestEnvironment _testEnvironment;

        public override bool Verbose
        {
            get
            {
                return true;
            }
            set
            {
            }
        }

        protected TestEnvironment TestEnvironment
        {
            get
            {
                if ( _testEnvironment == null )
                {
                    if ( Configuration == null )
                    {
                        throw new BuildException( "Call 'prepare-vm' task first" );
                    }
                    Log( Level.Info, "Preparing VM..." );
                    _testEnvironment = new TestEnvironment( Configuration );
                    _testEnvironment.InitializeCleanEnvironment();
                    Log( Level.Info, "VM is reverted to '{0}' snapshot", Configuration.CleanSnapshotName );
                }
                return _testEnvironment;
            }
        }
    }
}